﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGridDictionary
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
           
            InitializeComponent();
            this.DataContext = new WorkList();
           
        }
        private void myGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            WorkList l = new WorkList();

              
               foreach (var key in l.WorkListItems[0].Items)
               {
                   var f = new UnboundField
                   {
                       Label = key.Key,
                       Binding = new Binding
                       {
                           Path = new PropertyPath("Items[" + key.Key + "]")
                       }
                   };
                   e.FieldLayout.Fields.Add(f);
               }
            
        }
       
    }

    public class WorkList : INotifyPropertyChanged
    {
      
        public WorkList()
        {
            LoadData();
            
        }
        public List<WorkListItem> Items;

        private List<WorkListItem> _workListItems;
        public List<WorkListItem> WorkListItems
        {
            get { return _workListItems; }
            set
            {
                _workListItems = value;
                RaisePropertyChanged("WorkListItems");
            }
        }
        
        private void LoadData()
        {
            this.WorkListItems = new List<WorkListItem>();
            WorkListItem wli = new WorkListItem();
            wli.Items = new Dictionary<string, string>();
            wli.Items.Add("One", "1");
            wli.Items.Add("Two", "2");
            wli.Items.Add("Three", "3");
            this.WorkListItems.Add(wli);

            WorkListItem wli2 = new WorkListItem();
            wli2.Items = new Dictionary<string, string>();
            wli2.Items.Add("One", "11");
            wli2.Items.Add("Two", "22");
            wli2.Items.Add("Three", "33");
            this.WorkListItems.Add(wli2);


            WorkListItem wli3 = new WorkListItem();
            wli3.Items = new Dictionary<string, string>();
            wli3.Items.Add("One", "111");
            wli3.Items.Add("Two", "222");
            wli3.Items.Add("Three", "333");
            this.WorkListItems.Add(wli3);
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class WorkListItem : INotifyPropertyChanged
    {
        private Dictionary<string, string> _items;
        public Dictionary<string, string> Items
        {
            get { return _items; }
            set
            {
                _items = value;
                RaisePropertyChanged("Items");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    class MyConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //string parm = parameter as string;
            //if (parm == "Test")
            //{
            //    Test t = (Test)value;
            //    return t.Values;
            //}
            //else
            //{

            //    if (parm == "Name")
            //    {
            //        KeyValuePair<int, Test> kvp = (KeyValuePair<int, Test>)value;
            //        return kvp.Value.Name;
            //    }

            //}
            return value;

        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
